<?php
session_start();
if(!file_exists("config/settings.dat") || filemtime("config/settings.ini")>filemtime("config/settings.dat")){
 $settings = parse_ini_file("config/settings.ini", true);
 file_put_contents("config/settings.dat", json_encode($settings));
 exec("sudo sync");
}
$settings = json_decode(file_get_contents("config/settings.dat"),TRUE);

exec( "cat /proc/device-tree/model", $output, $returned );
if(strpos(implode($output),"Raspberry")!==FALSE){
	$settings['Options']['Processor']="Raspberry Pi";
	$type="1";
	include("include/netops.php");
}elseif(strpos(implode($output),"Banana")!==FALSE){
	$settings['Options']['Processor']="Banana Pi";
	$type="0";
	include("include/netops2.php");
}elseif(strpos(implode($output),"Orange")!==FALSE){
	$settings['Options']['Processor']="Orange Pi";
	$type="0";
	include("include/netops2.php");
} else {
	$settings['Options']['Processor']="Other";
	include("include/netops2.php");
	$type="1";
}

$stateFile=$settings['State']['FileName'];
if(file_exists($stateFile)){
	$spkrData = json_decode(file_get_contents($stateFile),TRUE);
}else{
	$spkrData = [
			"Spkr1" => "On", "Spkr2" => "Off", "Spkr3" => "Off", "Spkr4" => "Off",
			"Spkr5" => "Off", "Spkr6" => "Off", "Spkr7" => "Off", "Spkr8" => "Off",
			"Order" => [ "0" => "Spkr1" ]
	];
	file_put_contents($stateFile, json_encode($spkrData));
	exec("sudo sync");
	// set first speaker set 1-4
	$mask=0;
	for ($count=1;$count<5;$count++){
		if($spkrData['Spkr'.$count]=='On'){
			$mask+=1<<($count-1);
		}
	}
	// TBD - hard coded for device 0x20 (and index2.php one higher)
	// i2cset [-f] [-y] [-m mask] [-r] i2cbus chip-address data-address [value] ...  [mode]
	$command='sudo i2cset -y '.$type.' 0x20 0x09 '.$mask;
	exec($command); // set the speakers
	// set second speaker set 5-8
	$mask=0;
	for ($count=5;$count<9;$count++){
		if($spkrData['Spkr'.$count]=='On'){
			$mask+=1<<($count-5);
		}
	}
	// TBD - hard coded for device 0x22 (which is one device above 0x20)
	// i2cset [-f] [-y] [-m mask] [-r] i2cbus chip-address data-address [value] ...  [mode]
	$command='sudo i2cset -y '.$type.' 0x21 0x09 '.$mask;
	exec($command); // set the speakers
}

function DisplaySpkrBtn($Spkr,$State,$Name,$labelOptions){
  if($Spkr>0 && $Spkr<17){
    echo '<button type="button" class="spkr"';
    if($State=="On") echo ' style="color: green; ';
    else echo ' style="color: red; ';
    if($labelOptions['font-size']!="default") echo $labelOptions['font-size'];

    echo '" id="spl'.$Spkr.'" name="spl'.$Spkr.'" onClick="flip_spkr(this); window.location.href = \'';

    //$current_url = explode("?", $_SERVER['REQUEST_URI']);
    $current_url = explode("?", $_SERVER['SCRIPT_NAME']);

    echo $current_url[0];
    echo '?spl'.$Spkr.'=Pressed'."&amp;".'spkr='.$Spkr.'\'">';
    if($labelOptions['text-weight']=="bold") echo "<b>";
    if($labelOptions['text-type']=="italics") echo "<i>";

    if($labelOptions['line-breaks']=="on"){
      if(strlen($Name)>0) echo str_replace(' ','<br>',$Name).'<br> '.$State;
      else echo $State;
    }else{
      if(strlen($Name)>0) echo $Name.'<br> ';
      echo $State;
    }
    
    if($labelOptions['text-type']=="italics") echo "</i>";
    if($labelOptions['text-weight']=="bold") echo "</b>";
    echo "</button>";
  }
}

function OldDisplaySpkrBtn($Spkr,$State,$Name){
    if($Spkr>0 && $Spkr<17){
        echo '<form name="sp'.$Spkr.'" method="GET" ><input type="submit" id="spl'.$Spkr.'" name="spl'.$Spkr.'" value="';
        if(strlen($Name)>0) echo $Name.'&#13;&#10; ';
        echo $State;
        if($State=="On") echo '" style="color: green;"';
        else echo '" style="color: red;"';
        echo ' class="speaker" onclick="flip_spkr(this)"><input type="hidden" name="spkr" value="'.$Spkr.'"></form>';
    }
}

// TBD - does not display correctly. Figure out why, fix and then use.
function DisplayCustomBtns($settings){
	if(isset($settings['Buttons']['URL1'])&&isset($settings['Buttons']['URL2'])&&isset($settings['Buttons']['Label1'])&&isset($settings['Buttons']['Label2'])&&$settings['Buttons']['URL1']!="" && $settings['Buttons']['Label1']!="" && $settings['Buttons']['URL2']!="" && $settings['Buttons']['Label2']!=""){
		echo '<div class="divTableCell"><button class="command" style="'.$settings['LabelOptions']['font-size'].'" onclick="parent.location=\''.$settings['Buttons']['URL1'].'\'">'.$settings['Buttons']['Label1'].'</button></div>';
		echo '<div class="divTableCell"><button class="command" style="'.$settings['LabelOptions']['font-size'].'" onClick="parent.location=\''.$settings['Buttons']['URL2'].'\'">'.$settings['Buttons']['Label2'].'</button></div>';
	}elseif(isset($settings['Buttons']['URL1'])&&isset($settings['Buttons']['Label1'])&&$settings['Buttons']['URL1']!="" && $settings['Buttons']['Label1']!=""){
		echo '<div class="divTableCell"><button class="command" style="'.$settings['LabelOptions']['font-size'].'" onclick="parent.location=\''.$settings['Buttons']['URL1'].'\'">'.$settings['Buttons']['Label1'].'</button></div>';
		echo '<div class="divTableCell"></div>';
	}elseif(isset($settings['Buttons']['URL2'])&&isset($settings['Buttons']['Label2'])&&$settings['Buttons']['URL2']!="" && $settings['Buttons']['Label2']!=""){
		echo '<div class="divTableCell"><button class="command" style="'.$settings['LabelOptions']['font-size'].'" onClick="parent.location=\''.$settings['Buttons']['URL2'].'\'">'.$settings['Buttons']['Label2'].'</button></div>';
		echo '<div class="divTableCell"></div>';
	}
}

?>
<!DOCTYPE HTML>
<html lang="en">
<head>
<title>Katoomba Sound</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<meta charset="UTF-8">
<link rel="icon" type="image/x-icon" href="favicon.ico">
<link rel="stylesheet" href="<?php echo $settings['Options']['StyleSheet']?>?v=<?php echo date('his');?>" type="text/css" >
<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
<script src="scripts/katoombasound.js"></script>
